﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;

namespace WindowsFormsApplication4
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void ultraGrid1_InitializeRow(object sender, Infragistics.Win.UltraWinGrid.InitializeRowEventArgs e)
        {
            // Look for rows in the child band.
            if (e.Row.Band.Key == "Band 1")
            {
                // Examine the ShowChildColumns cell in the parent row to see if we should be
                // showing the child column. 
                bool showChildColumns = (bool)e.Row.ParentRow.Cells["ShowChildColumns"].Value;

                e.Row.Cells["Column 3"].Hidden = !showChildColumns;
                e.Row.Cells["Column 4"].Hidden = !showChildColumns;
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.ultraGrid1.CreationFilter = new MyCreationFilter();
            this.uiElementViewerDialog1.Show(this, new Point(this.Bounds.Right, this.Bounds.Top));
        }

        public class MyCreationFilter : IUIElementCreationFilter
        {
            public void AfterCreateChildElements(UIElement parent)
            {
                // do nothing. 
            }

            public bool BeforeCreateChildElements(UIElement parent)
            {
                HeaderUIElement headerUIElement = parent as HeaderUIElement;
                if (null != headerUIElement)
                {
                    UltraGridColumn column = headerUIElement.GetContext(typeof(UltraGridColumn)) as UltraGridColumn;
                    if (null != column)
                    {
                        switch (column.Key)
                        {
                            case "Column 3":
                            case "Column 4":
                                // return true here to tell the parent element not to add any child
                                // elements (such as the TextUIElement which displays the column header
                                // caption).
                                parent.ChildElements.Clear();
                                return true;
                        }
                    }

                }

                // Do nothing. 
                return false;
            }
        }
    }
}
